"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = deleteQueue;
const crud_1 = __importDefault(require("../../../utils/data-fetching/crud"));
const get_queue_1 = __importDefault(require("./get-queue"));
function deleteQueue(_a) {
    return __awaiter(this, arguments, void 0, function* ({ queueId, userId }) {
        const tableName = "process_queue";
        const existingQueue = (yield (0, get_queue_1.default)({ userId, queueId }));
        if (!(existingQueue === null || existingQueue === void 0 ? void 0 : existingQueue.id))
            return false;
        const deleteQueueRes = yield (0, crud_1.default)({
            action: "delete",
            table: tableName,
            targetId: existingQueue.id,
        });
        return Boolean(deleteQueueRes === null || deleteQueueRes === void 0 ? void 0 : deleteQueueRes.success);
    });
}
