import sqlGenerator from "../../functions/dsql/sql/sql-generator";
import { DsqlMethodCrudParam, ServerQueryParam } from "../../types";
export type APIDataCrudQuery = ServerQueryParam & {
    page?: number;
};
export type CRUDResponseObject<P extends any = any> = {
    success: boolean;
    payload?: P;
    msg?: string;
    error?: string;
    queryObject?: ReturnType<Awaited<typeof sqlGenerator>>;
};
export default function dsqlMethodCrud<T extends {
    [key: string]: any;
} = {
    [key: string]: any;
}, P extends {
    [key: string]: any;
} = {
    [key: string]: any;
}>({ method, tableName, addUser, user, extraData, transformData, existingData, body, query, targetId, sanitize, transformQuery, debug, }: DsqlMethodCrudParam<T>): Promise<CRUDResponseObject<P>>;
